
#ifndef ConstraintGenotypeC_h
#define ConstraintGenotypeC_h 1


#include "FitnessC.h"
#include "../Problem/randomcsp.h"
#include "../Common/FileC.h"
#include "../Types.h"
#include <iomanip.h>



typedef UnsignedIntegerT ConstraintFitnessT;
typedef UnsignedIntegerT ConstraintGeneT;

class EncounterC;

class ConstraintGenotypeC 
{
	public:

		ConstraintGenotypeC
		(
			ConstraintGeneT iVariable1,
			ConstraintGeneT iVariable2,
			UnsignedIntegerT iSizeOfFitnessHistory,
			RandomCspC * iProblem
		);

		ConstraintGenotypeC
		(
			const ConstraintGenotypeC & iGenotpye
		);

		~ConstraintGenotypeC ();

		const ConstraintGenotypeC & operator=
		(
			ConstraintGenotypeC const & iGenotpye
		);

		void const Print () const;

		void const Print
		(
			FileC iFile
		) const;

		ConstraintFitnessT const GetFitnessValue () const;

		ConstraintGeneT const GetVariable1 () const;
		ConstraintGeneT const GetVariable2 () const;

		void const UpdateFitness
		(
			BoolT iReward
		);

		void const InitialiseFitness
		(
			EncounterC * iEncounter
		);

	protected:

	private:

		FitnessC <UnsignedIntegerT> * Fitness;

		ConstraintGeneT Variable1;
		ConstraintGeneT Variable2;

		RandomCspC * Problem;

}; // ConstraintGenotypeC


#endif

// eof ConstraintGenotypeC.h
