
#include "EncounterC.h"



EncounterC::EncounterC
(
	UnsignedIntegerT iNumberOfEncounters,
	SolutionPopulationC * iSolutionPopulation,
	ConstraintPopulationC * iConstraintPopulation,
	RandomCspC * iProblem
)
{
	NumberOfEncounters = iNumberOfEncounters;
	ConstraintPopulation = iConstraintPopulation;
	SolutionPopulation = iSolutionPopulation;
	Problem = iProblem;
	TotalNumberOfEncounters = 0;

} // EncounterC::EncounterC
		


EncounterC::~EncounterC ()
{

} // EncounterC::~EncounterC



void const EncounterC::DoIt
(
	ConstraintGenotypeC * ConstraintGenotype
)
{
	UnsignedIntegerT i;
	SolutionGenotypeC * SolutionGenotype;

	for (i = 0; i < NumberOfEncounters; i++)
	{
		SolutionGenotype = SolutionPopulation->FetchGenotype ();

		if
		(
			Problem->IsConflict
			(
				ConstraintGenotype->GetVariable1 (),
				ConstraintGenotype->GetVariable2 (),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable1 ()),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable2 ())
			)
		)
		{
			//SolutionGenotype->UpdateFitness (false);
			ConstraintGenotype->UpdateFitness (true);
		}
		else
		{

			//SolutionGenotype->UpdateFitness (true);
			ConstraintGenotype->UpdateFitness (false);
		}

		TotalNumberOfEncounters++;
		SolutionPopulation->InjectGenotype (SolutionGenotype);
	}

} // EncounterC::DoIt



void const EncounterC::DoIt
(
	SolutionGenotypeC * SolutionGenotype
)
{
	UnsignedIntegerT i;
	ConstraintGenotypeC * ConstraintGenotype;

	for (i = 0; i < NumberOfEncounters; i++)
	{
		ConstraintGenotype = ConstraintPopulation->FetchGenotype ();

		if
		(
			Problem->IsConflict
			(
				ConstraintGenotype->GetVariable1 (),
				ConstraintGenotype->GetVariable2 (),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable1 ()),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable2 ())
			)
		)
		{
			SolutionGenotype->UpdateFitness (false);
			//ConstraintGenotype->UpdateFitness (true);
		}
		else
		{

			SolutionGenotype->UpdateFitness (true);
			//ConstraintGenotype->UpdateFitness (false);
		}

		TotalNumberOfEncounters++;
		ConstraintPopulation->InjectGenotype (ConstraintGenotype);
	}

} // EncounterC::DoIt



void const EncounterC::DoIt ()
{
	UnsignedIntegerT i;
	ConstraintGenotypeC * ConstraintGenotype = 0;
	SolutionGenotypeC * SolutionGenotype = 0;

	for (i = 0; i < NumberOfEncounters; i++)
	{
		SolutionGenotype = SolutionPopulation->FetchGenotype ();
		ConstraintGenotype = ConstraintPopulation->FetchGenotype ();

		if
		(
			Problem->IsConflict
			(
				ConstraintGenotype->GetVariable1 (),
				ConstraintGenotype->GetVariable2 (),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable1 ()),
				SolutionGenotype->GetGene (ConstraintGenotype->GetVariable2 ())
			)
		)
		{
			SolutionGenotype->UpdateFitness (false);
			ConstraintGenotype->UpdateFitness (true);
		}
		else
		{

			SolutionGenotype->UpdateFitness (true);
			ConstraintGenotype->UpdateFitness (false);
		}

		TotalNumberOfEncounters += 2;
		SolutionPopulation->InjectGenotype (SolutionGenotype);
		ConstraintPopulation->InjectGenotype (ConstraintGenotype);
	}
} // EncounterC::DoIt



UnsignedIntegerT const EncounterC::GetTotalNumberOfEncounters ()
{
	return (TotalNumberOfEncounters);
	
} // EncounterC::GetTotalNumberOfEncounters



// eof EncounterC.cc
