
#ifndef EncounterC_h
#define EncounterC_h

#include "../Types.h"
#include "SolutionGenotypeC.h"
#include "ConstraintGenotypeC.h"
#include "SolutionPopulationC.h"
#include "ConstraintPopulationC.h"

class SolutionPopulationC;
class ConstraintPopulationC;
class ConstraintGenotypeC;
class SolutionGenotypeC;

class EncounterC
{
	public:

		EncounterC
		(
			UnsignedIntegerT iNumberOfEncounters,
			SolutionPopulationC * iSolutionPopulation,
			ConstraintPopulationC * iConstraintPopulation,
			RandomCspC * iProblem
		);
		
		~EncounterC ();

		void const DoIt
		(
			ConstraintGenotypeC * ConstraintGenotype
		);

		void const DoIt
		(
			SolutionGenotypeC * SolutionGenotype
		);

		void const DoIt ();

		UnsignedIntegerT const GetTotalNumberOfEncounters ();

	protected:

	private:

		ConstraintPopulationC * ConstraintPopulation;
		SolutionPopulationC * SolutionPopulation;

		UnsignedIntegerT NumberOfEncounters;
		UnsignedIntegerT TotalNumberOfEncounters;

		RandomCspC * Problem;

}; // EncounterC

#endif

// eof EncounterC.h
