
#ifndef ExperimentC_h
#define ExperimentC_h 1

#include "Coga/EvolutionaryAlgorithmC.h"
#include "ConfigurationC.h"
#include "StatisticsC.h"
#include "Problem/pprosser.h"
#include "Problem/gvdozier.h"
#include <MLCG.h>
#include <unistd.h>


class ExperimentC 
{
	public:

		ExperimentC
		(
			StringT iConfigurationFileName
		);

		~ExperimentC ();

	protected:

		void const DoProblemParametersettingsExperiment ();

		void const DoDifferentProblemsTest
		(
			PositiveIntegerT iNumberOfVariables,
			PositiveIntegerT iDomainSize,
			BoolT iRandomDomainSize,
			ZeroToOneRealRealT iTightness,
			ZeroToOneRealRealT iConnectivity
		);

		void const DoMultipleTimesOneProblemTest
		(
			PositiveIntegerT iNumberOfTimes,
			PositiveIntegerT iNumberOfVariables,
			PositiveIntegerT iDomainSize,
			BoolT iRandomDomainSize,
			ZeroToOneRealRealT iTightness,
			ZeroToOneRealRealT iConnectivity
		);

	private:

		typedef enum ProblemGeneratorMethodE
		{
			none,
			Dozier,
			Prosser
		} ProblemGeneratorMethodT;

		static StringT ProblemGeneratorMethods [];
		ProblemGeneratorMethodT ProblemGeneratorMethod;

		ConfigurationC * ConfigurationFile;

		EvolutionaryAlgorithmC * EvolutionaryAlgorithm;

		StatisticsC * Statistics;

		RandomCspC * Problem;


}; // ExperimentC.h

#endif

// eof ExperimentC.h
