#include "StatisticsC.h"

StatisticsC::StatisticsC
(
	StringT const iIntermediateFileName,
	StringT const iRunStatsFileName,
	StringT const iSuccessRateFileName,
	StringT const iEncountersDoneFileName,
	StringT const iGeneratedGenotypesFileName,
	StringT const iGenerationsFileName,
	StringT const iDirectory,
	BoolT const iOverwriteOutputFiles
)
{
	// NOT USED // IntermediateFile = new FileC (iIntermediateFileName);
	StringT temp;
	temp = iIntermediateFileName;


	temp = new char [strlen (iDirectory) + 1 + strlen (iRunStatsFileName)];
	temp = strcpy (temp, iDirectory);
	temp = strcat (temp, iRunStatsFileName);
	RunStatsFile = new FileC (temp, iOverwriteOutputFiles);
	delete temp;

	temp = new char [strlen (iDirectory) + 1 + strlen (iSuccessRateFileName)];
	temp = strcpy (temp, iDirectory);
	temp = strcat (temp, iSuccessRateFileName);
	PlotSuccessRateFile = new FileC (temp, iOverwriteOutputFiles);
	*PlotSuccessRateFile << "# Connectivity : Tightness : SuccessRate\n";
	delete temp;

	temp = new char [strlen (iDirectory) + 1 + strlen (iEncountersDoneFileName)];
	temp = strcpy (temp, iDirectory);
	temp = strcat (temp, iEncountersDoneFileName);
	PlotEncountersDoneFile = new FileC (temp, iOverwriteOutputFiles);
	*PlotEncountersDoneFile << "# Connectivity : Tightness : Number of encounters made\n";
	delete temp;

	temp = new char [strlen (iDirectory) + 1 + strlen (iGeneratedGenotypesFileName)];
	temp = strcpy (temp, iDirectory);
	temp = strcat (temp, iGeneratedGenotypesFileName);
	PlotGeneratedGenotypesFile = new FileC (temp, iOverwriteOutputFiles);
	*PlotGeneratedGenotypesFile << "# Connectivity : Tightness : Number of genotypes generated\n";
	delete temp;

	temp = new char [strlen (iDirectory) + 1 + strlen (iGenerationsFileName)];
	temp = strcpy (temp, iDirectory);
	temp = strcat (temp, iGenerationsFileName);
	PlotGenerationsFile = new FileC (temp, iOverwriteOutputFiles);
	*PlotGenerationsFile << "# Connectivity : Tightness : Number of generations\n";
	delete temp;

	Reset ();
}


StatisticsC::~StatisticsC ()
{
	// NOT USED // delete IntermediateFile;
	delete RunStatsFile;
	delete PlotSuccessRateFile;
	delete PlotEncountersDoneFile;
	delete PlotGeneratedGenotypesFile;
	delete PlotGenerationsFile;
}



void const StatisticsC::WriteExperimentResult ()
{
	// Any last words?
}

void const StatisticsC::WriteOneParameterResult
(
	RealT Connectivity,
	RealT Tightness
)
{
	*PlotSuccessRateFile << Connectivity << " " << Tightness << " " << ((RealT) SuccessCounter / (RealT) ProblemCounter) << "\n";
	if (SuccessCounter > 0)
	{
		*PlotEncountersDoneFile << Connectivity << " " << Tightness << " " << ((RealT) NumberOfEncountersDoneTotal / (RealT) SuccessCounter) << "\n";
		*PlotGeneratedGenotypesFile << Connectivity << " " << Tightness << " " << ((RealT) NumberOfGeneratedGenotypesTotal / (RealT) SuccessCounter) << "\n";
		*PlotGenerationsFile << Connectivity << " " << Tightness << " " << ((RealT) NumberOfGenerationsTotal / (RealT) SuccessCounter) << "\n";
	}
	else
	{
		*PlotEncountersDoneFile << Connectivity << " " << Tightness << " " << (RealT) NumberOfEncountersDoneTotal << "\n";
		*PlotGeneratedGenotypesFile << Connectivity << " " << Tightness << " " << (RealT) NumberOfGeneratedGenotypesTotal << "\n";
		*PlotGenerationsFile << Connectivity << " " << Tightness << " " << (RealT) NumberOfGenerationsTotal << "\n";
	}

	Reset ();
}



void const StatisticsC::WriteOneProblemTestResult
(
	BoolT iSucces,
	UnsignedIntegerT iNumberOfEncountersDone,
	UnsignedIntegerT iNumberOfGenerations,
	UnsignedIntegerT iNumberOfGeneratedGenotypes
)
{
	ProblemCounter++;

	*RunStatsFile << "R\t\t\t" << ProblemCounter << ". ";

	if (iSucces)
	{
		*RunStatsFile
			<< "Found solution\n"
			<< "E\t\t\t" << iNumberOfEncountersDone << "\n"
			<< "G\t\t\t" << iNumberOfGenerations << "\n"
			<< "GG\t\t\t" << iNumberOfGeneratedGenotypes << "\n"
		;

		SuccessCounter++;
		NumberOfEncountersDoneTotal += iNumberOfEncountersDone;
		NumberOfGenerationsTotal += iNumberOfGenerations;
		NumberOfGeneratedGenotypesTotal += iNumberOfGeneratedGenotypes;
	}
	else
	{
		*RunStatsFile << "Found NO solution\n";

		NumberOfGenerationsMaximum = iNumberOfGenerations;
		NumberOfGeneratedGenotypesMaximum = iNumberOfGeneratedGenotypes;
		NumberOfEncountersDoneMaximum = iNumberOfEncountersDone;
	}

}




void const StatisticsC::WriteIntermediateResults ()
{
	// No use for it yet...
	cerr << "Warning: Intermediate file has not been implemented yet.\n";
}


FileC & StatisticsC::GetFileToStoreSolutions ()
{
	return (*RunStatsFile);
}

void const StatisticsC::Reset ()
{
	NumberOfEncountersDoneTotal = 0;
	NumberOfGenerationsTotal = 0;
	NumberOfGeneratedGenotypesTotal = 0;
	ProblemCounter = 0;
	SuccessCounter = 0;
}


StatisticsC & StatisticsC::operator<<
(
	StringT const iString
)
{
	*RunStatsFile << iString;

	return (*this);

} // StatisticsC::operator<<

StatisticsC & StatisticsC::operator<<
(
	UnsignedIntegerT const iUnsignedInteger
)
{
	*RunStatsFile << " = " << iUnsignedInteger << "\n";

	return (*this);
	
} // StatisticsC::operator<<

StatisticsC & StatisticsC::operator<<
(
	BoolT const iBool
)
{
	if (iBool)
	{
		*RunStatsFile << " = true\n";
	}
	else
	{

		*RunStatsFile << " = false\n";
	}

	return (*this);
	
} // StatisticsC::operator<<

StatisticsC & StatisticsC::operator<<
(
	RealT const iReal
)
{
	*RunStatsFile << " = " << iReal << "\n";

	return (*this);
	
} // StatisticsC::operator<<



// eof StatisticsC.cc
